/*
 * StringList.java
 *
 * Created on 10 October 2008, 17:06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package dosagenumbers;

/**
 *
 * @author pcairns
 */

import java.util.*;
import java.io.*;

public class StringList{

    Vector fList;
 
    public StringList(){
	fList = new Vector();
    }//constructor StringList

 
    public void add( String pString ){
        fList.add( pString );
    }
 
    public void add( StringList pStringList ){
        int lAddSize = pStringList.size();
        int lAddCount;
        String lThisString;

        for( lAddCount = 0; lAddCount < lAddSize; lAddCount++ ){
	    lThisString = pStringList.elementAt( lAddCount );
            add( lThisString );
        }//for
    }//add

    public String elementAt( int pIndex ){
        return (String) fList.elementAt( pIndex );
    }//elementAt

    public void setElementAt( String pReplacement, int pIndex ){
        fList.setElementAt( pReplacement, pIndex );
    }//setElementAt


    public boolean ContainsString( String pSearchText ){
        int lListSize = size();
        int lListCount,
            lTextPos;
        String lThisLine;
        boolean lFoundIt = false;

        for( lListCount = 0; 
             (lListCount < lListSize) && !lFoundIt; 
             lListCount++ ){
	    lThisLine = elementAt( lListCount );
            lTextPos = lThisLine.indexOf( pSearchText );
            if( lTextPos != -1 ){
		lFoundIt = true;
            }
        }//for lListCount

        return lFoundIt;
    }//ContainsString

    public void FromFile( String pFileName ){
        DataInputStream lInput = null;
         boolean lEOF = false;
        String lThisLine;
 
	fList = new Vector();

        //Open file
        try
        {
	  lInput = new DataInputStream( new FileInputStream( pFileName ) );

	  while( !lEOF )
	  {
	    try
	    {
	        lThisLine = lInput.readLine();
	        if( lThisLine != null )
	        {
		    add( lThisLine );
	        }
	        else
	        {
		  lEOF = true;
	        }//if lThisLine
	    }
	    catch( EOFException e )
	    {
	      lEOF = true;
	    }//try readLine
	  }//while !EOF	

        lInput.close();	
      }
      catch( IOException e )
      {
	System.out.println( "Unable to read list: " + pFileName );
        System.out.println( e.getMessage() );
      }//try   
      
    }//FromFile

    public void toFile( String pDir, String pName ){
      File lThisFile;

      lThisFile =  new File( pDir, pName);
      BufferedWriter lOutput;

      //Open file
      try
      {
        lOutput = new BufferedWriter( new FileWriter( lThisFile ) );
        WriteContent( lOutput );
        lOutput.close();    
      }
      catch( IOException e )
      {
        System.out.println( "Unable to write output file" );
        System.out.println( e.getMessage() );
      }//try
    }//ToFile

    protected void WriteContent( BufferedWriter pOutput ) throws IOException
    {
        int lStringCount, lNumOfStrings = size();
        String lThisString;

        for( lStringCount = 0; lStringCount < lNumOfStrings; lStringCount++ ){
	    lThisString = elementAt( lStringCount );
	     pOutput.write( lThisString );
             pOutput.newLine();
        }//for lStringCount
    }//WriteContent



    public void out(){
	int lCount;
        int lListSize = size();
        String lThisString;

        for( lCount = 0; lCount < lListSize; lCount++ ){
            lThisString = elementAt( lCount );
            System.out.println( lThisString );
        }//for lCount
    }//out

    public int size(){
        return fList.size();
    }
}
