/*
 * ErrorRates.java
 *
 * Created on 18 May 2009, 15:44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package dosagenumbers;

/**
 *
 * @author pcairns
 */
public class ErrorRates {
    
    public static double KEYPRESS = 0.01;
    public static double TRUNCATE = 0.01;
    public static double SPECIFIC = KEYPRESS/(Keys.numNonTruncatingKeys() - 1);
    public static double TOTAL = KEYPRESS + TRUNCATE;
    
    /** Creates a new instance of ErrorRates */
    public ErrorRates() {
    }
    
    public static void setKeyPressErrorRate( double pRate ){
        KEYPRESS = pRate;
        recalculate();
    }
    
    public static void setTruncateErrorRate( double pRate ){
        TRUNCATE = pRate;
        recalculate();
    }
    
    private static void recalculate(){
        SPECIFIC = KEYPRESS/(Keys.numNonTruncatingKeys() - 1);
        TOTAL = KEYPRESS + TRUNCATE;
    }
    
}
