/*
 * ErrorSummary.java
 *
 * Created on 18 May 2009, 16:06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package dosagenumbers;

/**
 *
 * @author pcairns
 */
public class ErrorSummary {
    
    private String fDosage;
    private double fCorrectProb;
    private double fInvalidProb;
    private double fBadDoseProb;
    private double fBadAndInvalidProb;
    private double fBadR;
    
    public final static String SEP = ",";
    
    /** Creates a new instance of ErrorSummary */
    public ErrorSummary( String pDosage ) {
        fDosage = pDosage;
    }
    
    public void setCorrectProb( double pProb ){
        fCorrectProb = pProb;
    }
    
    public void setBadDoseProb( double pProb ){
        fBadDoseProb = pProb;
    }
    
    public void setInvalidProb( double pProb ){
        fInvalidProb = pProb;
    }
    
    public void setBadAndInvalidProb( double pProb ){
        fBadAndInvalidProb = pProb;
    }
    
    public void setBadR( double pBadR ){
        fBadR = pBadR;
    }
    
    public static String format(){
        return "Dosage,Correct,Invalid,PropErr,PropErrAndInvalid,PropR";
    }
    
    public String asString(){
        String lAnswer = fDosage + SEP + fCorrectProb + SEP + fInvalidProb + SEP + fBadDoseProb + SEP 
                         + fBadAndInvalidProb + SEP + fBadR;
        return lAnswer;
    }
    
}
